BEGIN{
     USE_INC = inc;
     if (USE_INC == "")
        USE_INC = "none";
     USE_NAME = toupper(name);
     if (USE_NAME == "")
        USE_NAME = "NONE";
     printf("/*\n     Autogenerated file. Please do not edit.\n*/\n");
     printf("#include <stdlib.h>\n");
     printf("#include \"%s\"\n\n", USE_INC);
     printf("struct {\n     const char *n;\n     const char *v;\n} _CI_CONF_%s[] = {\n", USE_NAME);
}
{
   line = $0
   n = match(line, /^[[:space:]]*#[[:space:]]*define[[:space:]]+([[:alnum:]_]+)[[:space:]]*(.*)$/);
   if (n != 0) {
        sub(/^[[:space:]]*#[[:space:]]*define/, "", line);
        sub(/^[[:space:]]*/, "", line); # trim left
        len = index(line, " ");
        if (len > 0) {
            key = substr(line, 0 , len-1);
            value = substr(line, len);
            sub(/^[[:space:]]*/, "", value); # trim left
            sub(/[[:space:]]*$/, "", value); # trim right
            gsub(/"/, "\\\"", value); # escape quotes
        } else {
          key = line;
          value = "";
        }
        sub(/^[[:space:]]*/, "", key); # trim left
        sub(/[[:space:]]*$/, "", key); # trim right
        keynoargs=key;
        sub(/\(.*\)/, "", keynoargs);
        printf("#if defined(%s)\n     {\"%s\", \"%s\"},\n#endif\n", keynoargs, key, value);
   }
}
END{
     printf("     {NULL, NULL}\n};\n");
}
